<?php
$dir = dirname(__FILE__);
require_once( "$dir/duminica.php" );
require_once( "$dir/post.php" );
require_once( "$dir/pericopa.php" );
require_once( "$dir/pericopaLocal.php" );

class Pericopa
{
	var $capitol; // Capitolele pericopei (de ex. Matei XVII, 10-20; Luca X, 12)
	var $text; // Textul pericopei

	// Nu folositi metodele, sunt private
	function loadText( $sursa )
	{
		$pericopaObj = loadPericopa( $this->capitol ); // PericopaDetails
		$this->text .= $sursa->getPericopa( $pericopaObj );
	}
}

class Calendar
{
	var $titlu; // Numele sarbatorii principale (de ex. Buna Vestire)
	var $subtitlu; // Numele sarbatorii secundare (de ex. Sf. Haralambie)
	var $comentarii; // Indicatia din calendar (de ex. Inceputul Postului)
	var $Evanghelie; // Pericopa evanghelica (de tipul Pericopa)
	var $Apostol; // Pericopa apostolica (de tipul Pericopa)
	var $Liturghia; // O constanta LIT_* (din duminica.php)
	var $sursaPericopa; // Sursa de date pentru textul pericopei (de tip SursaDate)
	var $glas; // Glasul
	var $voscr; // Voscreasna

	// Se apeleaza pentru a incarca textul pericopelor apostolica si evanghelica
	function loadPericopa()
	{
		$this->loadText( $this->Evanghelie );
		$this->loadtext( $this->Apostol );
	}

	// Nu folositi metodele, sunt private
	function add( $dayDetails )
	{
		if( $dayDetails )
		{
			$this->addMember( $dayDetails->title, $this->titlu );
			$this->addMember( $dayDetails->subtitle, $this->subtitlu );
			$this->addMember( $dayDetails->Ev_title, $this->comentarii );
			$this->addPericopa( $dayDetails->Ev, $this->Evanghelie );
			$this->addPericopa( $dayDetails->Ap, $this->Apostol );
		}
	}

	function addMember( $value, &$toMember )
	{
		if( $value )
		{
			if( empty( $toMember ) )
			{
				$toMember = $value;
			}
			else
			{
				$toMember .= "; " . $value;
			}
		}
	}

	function addPericopa( $capitol, &$toMember )
	{
		if( $capitol )
		{
			if( empty( $toMember ) )
			{
				$pericopa = new Pericopa;
				$toMember = $pericopa;
			}
			$this->addMember( $capitol, $toMember->capitol );
		}
	}

	function loadText( &$pericopa )
	{
		if( $pericopa )
		{
			$pericopa->loadText( $this->sursaPericopa );
		}
	}
}

/*
IN: $date: int = data calendaristica. Implicit data curenta.
OUT: Calendar = obiect cu detaliile zilei
*/
function getCalendar( $date = FALSE )
{
	if( !$date )
	{
		$date = time() - date_offset_get( date_create());
	}
	$zi = getdate( $date );
	$year = $zi["year"];
	$Easter = getEasterDate( $year );
	$week = getWeekFromEaster( $zi, $Easter );
	$details = getDayDetails( $week, $Easter, false, $zi );
	$holiday = getHolidayDetails( $zi, $Easter );
	$calendar = new Calendar;
    $calendar->date = $date;
	$calendar->sursaPericopa = new PericopaLocal;
	$calendar->add( $details );
	$calendar->add( $holiday );
	$calendar->glas = $holiday->glas;
	$calendar->voscr = $holiday->voscr;
	$calendar->Liturghia = getLiturghiaName( $week, $zi );
    $post = getPost( $zi["mday"], $zi["mon"], $zi["year"] );
    $calendar->postText = getPostText( $post, $zi );
    $calendar->postPics = getPostPics( $post);
	return $calendar;
}

/*
IN: $azi: int = data calendaristica. Implicit data curenta.
OUT: int = data urmatoarei duminici
*/
function getNextSunday( $azi = FALSE )
{
	if( !$azi )
	{
		$azi = time();
	}
	$azi = getdate( $azi );
	$ziua = $azi["wday"];
	$avans = (7 - $ziua) % 7;
	$date = strtotime( "+" . $avans . " days", $azi );
	return $date;
}
?>