<?php
$dir = dirname(__FILE__);
require_once( "$dir/Pasti.php" );

define( "NEGRU", 0 );
define( "PAINE_APA", 1 );
define( "GRAU_MIERE", 2 );
define( "VEGETARIAN", 7 );
define( "ULEI_VIN", 15 );
define( "PESTE", 31 );
define( "LAPTE_OUA", 63 );
define( "CARNE", 127 );
define( "NUNTI", 255 );
define( "SEX", 256 );

function getPost( $day, $month, $year )
{
    static $IMPARATESTI_VAR = array( 38, 39, 48, 49, 50);
    static $IMPARATESTI_FIX = array("09-07","09-08","09-30","10-01","11-20","11-21","02-01","02-02","08-15");

	// Validation
    $day = intval( $day);
    $month = intval( $month);
    $year = intval( $year);
	if( $day < 1 || $day > 31 )
	{
		$err = "Day out of range: " . $day;
	}
	elseif( $month < 1 || $month > 12 )
	{
		$err = "Month out of range: " . $month;
	}
	else
	{
		$Easter = getEasterDate( $year );
		if( !$Easter )
		{
			$err = "Year out of range: " . $year;
		}
	}

	if( !empty( $err ))
	{
		die("<error>$err</error>");
	}

	if( $day < 10 )
	{
		$day = '0' . $day;
	}
	if( $month < 10 )
	{
		$month = '0' . $month;
	}
	$date = $year . '-' . $month . '-' . $day;
	$date = strtotime( $date );
	$zi = getdate( $date );
	$wday = $zi["wday"];
	$weekend = $wday == 6 || $wday == 0;
	$marti_joi = $wday == 2 || $wday == 4;
	$miercuri_vineri = $wday == 3 || $wday == 5;
	$week = getWeekFromEaster( $zi, $Easter );
	if( $Easter["mon"] == 5 && $Easter["mday"] >= 2 )
	{
		$weekAp = 50; // Daca Pastile cad dupa 2 mai postul Sf. Ap. Petru si Pavel incepe la Sf. Treime
	}
	else
	{
		$weekAp = 57; // altfel incepe la o saptamana dupa Sf. Treime
	}

	// Computation
	$post = CARNE; // deloc in zilele de rand

	// Zile de post de rand
	if( $miercuri_vineri ) // Miercurile si vinerile
	{
		if(( $month == 1 && $day < 5 ) // pana la Ajunul Bobotezei
            || ( $month == 1 && $day == 6 ) // Boboteaza (Botezul Domnului)
			|| $week == -67 // Miercurea din saptamana Vamesului si Fariseului
			|| $week == -65 // Vinerea din saptamana Vamesului si Fariseului
			|| $week == 3 // Miercurea din Saptamana Luminata
			|| $week == 5 // Vinerea din Saptamana Luminata
			|| $week == 52 // Miercurea din saptamana Rusaliilor
			|| $week == 54 // Vinerea din saptamana Rusaliilor
			|| ( $month == 12 && $day >= 25 ) // De la Craciun (Nasterea Domnului)
        )
		{
			$post = CARNE; // Harti
		}
		elseif( ($month == 1 && $day == 7 ) // +) Sf. Ioan Botezatorul
			|| ( $month == 2 && $day == 2 ) // (+) Stratenia (Intampinarea Domnului)
			|| ( $week >= 7 && $week < 49 ) // (+) Praznicul Cincizecimii
			|| ( $month == 6 && $day == 29 ) // (+) Sf. Ap. Petru si Pavel
            || ( $month == 6 && $day == 30 ) // + Soborul Sf. 12 Ap.
            || ( $month == 7 && $day == 12 ) // (†) Cinstirea Sf. Ic. a M. D. „Prodromița” de la Muntele Athos
			|| ( $month == 8 && $day == 15 ) // (+) Adormirea Maicii Domnului
            || ( $month == 9 && $day == 8 ) // (+) Nasterea Maicii Domnului
            || ( $month == 10 && $day == 1 )  // (+) Acoperamantul Maicii Domnului
        )
		{
			$post = PESTE;
		}
		elseif(( $month == 1 && $day == 11 ) // + Sf. Cuv. Theodosie
            || ( $month == 1 && $day == 17 ) // +) Sf. Cuv. Antonie
            || ( $month == 1 && $day == 18 ) // +) Sf. Ier. Atanasie si Chiril
            || ( $month == 1 && $day == 20 ) // + Sf. Cuv. Eftimie
            || ( $month == 1 && $day == 25 ) // + Sf. Ier. Grigorie Teologul
            || ( $month == 1 && $day == 27 ) // + Aducerea moastelor Sf. Ier. Ioan Gura de Aur
            || ( $month == 1 && $day == 30 ) // +) Sf. Trei Ierarhi
            || ( $month == 2 && $day == 10 ) // +) Sf. Mc. Haralambie
            || ( $month == 2 && $day == 24 ) // +) 1-a si a 2-a aflare a Capului Sf. Ioan Botezatorul
			|| ( $month == 3 && $day == 9 ) // +) Sf. 40 de Mucenici
            || ( $month == 5 && $day == 8 ) // +) Sf. Ap. si Ev. Ioan
            || ( $month == 5 && $day == 21 ) // +) Sf. Constantin si Elena
            || ( $month == 5 && $day == 25 ) // + A 3-a aflare a Capului Sf. Ioan Botezatorul
            || ( $month == 7 && $day == 17 ) // Sf. M. Mc. Marina
            || ( $month == 7 && $day == 20 ) // +) Sf. Ilie
            || ( $month == 7 && $day == 27 ) // +) Sf. M. Mc. Pantelimon
            || ( $month == 9 && $day == 26 ) // +) Adormirea Sf. Ioan Evanghelistul
            || ( $month == 10 && $day == 14 ) // +) Sf. Cuv. Parascheva
            || ( $month == 10 && $day == 26 ) // +) Sf. M. Mc. Dimitrie
            || ( $month == 11 && $day == 8 ) // +) Sf. Arh. Mihail si Gavriil
            || ( $month == 11 && $day == 13 ) // +) Sf. Ioan Hrisostom
            || ( $month == 11 && $day == 14 ) // + Sf. Ap. Filip
        )
		{
			$post = ULEI_VIN;
		}
		else
		{
			$post = VEGETARIAN;
		}
	}

	// Posturi de peste an
	if( $week >= -55 && $week < -48 ) // Saptamana Alba (a branzei)
	{
		$post = LAPTE_OUA;
	}
	elseif( $week >= -48 && $week < 0 ) // Postul Paresimilor (al Pastilor)
	{
		$post = VEGETARIAN;

        # http://www.crestinortodox.ro/paste/postul-pastelui/dezlegari-postul-sfintelor-pasti-140236.html
        # http://www.avantaje.ro/articol/postul-pastelui-2017-cum-se-tine-mod-corect-postul-mare
		if( $week == -2) // Vinerea Mare
		{
			$post = NEGRU;
		}
		elseif( $week == -48 // Luni, in prima saptamana
			|| $week == -47 // Marti, in prima saptamana
			|| $week == -6 // Lunea Mare
			|| $week == -5 // Martea Mare
			|| $week == -4 ) // Miercurea Mare
		{
			$post = PAINE_APA;
		}
        elseif( $weekend // Sambata si duminica
            || $week == -3 // Joia Mare
            || $week == -17 // Joia a V-a, dupa Canonul Mare
            || $month == 2 &&
                ( $day == 10 // +) Sf. Mc. Haralambie
                || $day == 24 // +) Aflarea Capului Sf. Ioan Botezatorul
                || $day == 29 ) // +) Sf. Cuv. Ioan Casian si Gherman din Dobrogea
            || $month == 3 && (
                $day == 9 // +) Sf. 40 de Mc. din Sevastia
                || $day == 24 // Inainte-praznuirea Bunei Vestiri
                || $day == 25 ) // Odovania Bunei Vestiri
            || $month == 4 && (
                $day == 11 // +) Sf. Ier. Calinic de la Cernica, ep. Ramnicului
                || $day == 12 // +) Sf. Mc. Sava de la Buzau
                || $day == 14 // +) Sf. Ier. Pahomie de la Gledin, ep. Romanului
                || $day == 20 // +) Sf. Teotim, ep. Tomisului
                || $day == 23 // +) Sf. M. Mc. Gheorghe, Purtatorul de biruinta
                || $day == 24 // +) Sf. Ier. Ilie Iorest, Simion Stefan si Sava Brancovici, mitropolitii Transilvaniei
                || $day == 25 ) // +) Sf. Cuv. Vasile de la Poiana Marului
            || $month == 5 &&
                ( $day == 2 // +) Sf. Ier. Atanasie al III-lea (Patelarie), patriarhul Constantinopolului
                || $day == 3 ) // +) Sf. Cuv. Irodion de la Lainici
            )
        {
            $post = ULEI_VIN;
        }

		if( $week == -7 ) // (+) Floriile
		{
			$post = PESTE;
		}

		if( $day == 25 && $month == 3 ) // (+) Blagovestenia (Buna Vestire)
		{
			if( $week < -3 )
			{
				$post = PESTE;
			}
			else
			{
				$post = ULEI_VIN;
			}
		}
	}
	elseif( $week >= $weekAp && ( $month == 5 || ( $month == 6 && $day < 29 ) ) ) // Postul Sf. Ap. Petru si Pavel
	{
		$post = VEGETARIAN;
		if( $marti_joi ) // Martea si joia
		{
			$post = ULEI_VIN;
		}

		if( $week == 50 || $weekend) // De Sf. Treime sau sambata si duminica
		{
			$post = PESTE;
		}

        if( $month == 6 &&
                $day == 11 // Sf. Ap. Bartolomeu si Barnaba
                || $day == 19 // Sf. Ap. Iuda, ruda Domnului
                || $day == 22 // +) Sf. Ier. Grigorie Dascalul
                || $day == 24 // (+) (Sanzienele) Nasterea Sf. Ioan Botezatorul
            )
        {
            $post = $miercuri_vineri ? ULEI_VIN : PESTE;
        }
	}
	elseif( $month == 8 && $day < 15 ) // Postul Adormirii Maicii Domnului
	{
		$post = VEGETARIAN;
		if( $day == 1 // Ziua Sf. Cruci
			|| $weekend ) // Sambata si duminica
		{
			$post = ULEI_VIN;
		}

		if( $day == 6 ) // (+) Pobrejenia (Schimbarea la Fata)
		{
			$post = PESTE;
		}
	}
	elseif( $month == 11 && $day >= 15
		|| $month == 12 && $day < 25 ) // Postul Craciunului
	{
		$post = VEGETARIAN;
		if( $month == 11 && $day >= 21
			|| $month == 12 && $day <= 20 ) // intre Vovidenie si Inaintepraznuirea Nasterii Domnului
		{
			if( $marti_joi ) // Martea si joia
			{
				$post = ULEI_VIN;
			}
			elseif( $weekend ) // Sambetele si duminicile
			{
				$post = PESTE;
			}
		}
		elseif( $weekend ) // Sambetele si duminicile de la inceputul si sfarsitul postului
		{
			$post = ULEI_VIN;
		}

		if( $month == 12 && $day == 24 ) // Ajunul Craciunului in timpul saptamanii
		{
			if( !$weekend )
			{
				$post = GRAU_MIERE;
			}
		}
		elseif( $month == 12 && $wday == 5 && ( $day == 23 || $day == 22 ) ) // Vinerea dinaintea Ajunului Craciunului
		{
			$post = GRAU_MIERE;
		}
		elseif( ( $month == 11 && (
            $day == 21 // (+) Vovidenia (Intrarea in Biserica a Maicii Domnului)
            || $day == 30 // +) Sf. Ap. Andrei
            ) )
            || ( $month == 12 &&
                $day == 6 // +) Sf. Ier. Nicolae
            ) )
        {
                $post = PESTE;
        }
        elseif( ( $month == 11 && (
                $day == 23 // +) Sf. Cuv. Antonie de la Iezerul Valcii
                || $day == 25 // +) Sf. M. Mc. Ecaterina
			) )
			|| ( $month == 12 && (
				$day == 3 // +) Sf. Cuv. Gheorghe de la Cernica si Caldarusani
                || $day == 4 // + Sf. M. Mc. Varvara
				|| $day == 5 // +) Sf. Cuv. Sava cel Sfintit
				|| $day == 7 // +) Sf. Mc. Filofteia de la Curtea de Arges
                || $day == 9 // + Zamislirea Sf. Fecioare Maria
				|| $day == 12 // +) Sf. Ier. Spiridon, Ep. Trimitundei
                || $day == 13 // +) Sf. Ier. Dosoftei, Mitr. Moldovei
                || $day == 18 // +) Sf. Cuv. Daniil Sihastrul
			) ) ) // Sfinti cu +) Priveghere sau cu + Doxologie mare
		{
			if( $miercuri_vineri ) // miercurea si vinerea
			{
				$post = ULEI_VIN;
			}
			else
			{
				$post = PESTE;
			}
		}
	}

	// Zile de post fixe
	elseif( ( $month == 8 && $day == 29 ) // +) Taierea Capului Sf. Ioan Botezatorul
		|| ( $month == 9 && $day == 14 ) ) // (+) Inaltarea Sf. Cruci
	{
		$post = ULEI_VIN;
	}
	elseif( $month == 1 && $day == 5 ) // Ajunul Bobotezei
	{
		$post = $weekend ? VEGETARIAN : NEGRU;
	}

    if( $post == CARNE){
        if( !(is_numeric( $week) && $week >= 0 && $week < 7) // Saptamana Luminata
            && !($month == 12 && $day >= 25 || $month == 1 && $day <= 6) // De la Craciun la Boboteaza
            && !in_array( $week, $IMPARATESTI_VAR) // Praznice imparatesti
            && !in_array("$month-$day", $IMPARATESTI_FIX)) {
            $post = NUNTI;
        }

        if( $wday == 2 || $wday == 4){ // martea si joia
            if( $month != 1 || $day < 5 || $day > 14){ // cand nu se ia Aghiasma Mare
                if( !isHoliday( $date, $Easter, $zi, $week)){ // azi nu e sarboatoare
                    if( !isHoliday( $date - 86400, $Easter )){ // ieri n-a fost sarbatoare
                        if( !isHoliday( $date + 86400, $Easter )){ // maine nu e sarbatoare
                            $post |= SEX;
                        }
                    }
                }
            }
        }
    }

	return $post;
}

function isHoliday( $date, $Easter, $zi = false, $week = false){
    if( !$zi) $zi = getdate( $date );
    if( !$zi['wday']) return true;

    if( $week === false) $week = getWeekFromEaster( $zi, $Easter );
    $details = getDayDetails( $week, $Easter, 'title', $zi );
    if( $details->title){
        return true;
    }

    $holiday = getHolidayDetails( $zi, $Easter, 'title' );
    if( $holiday->title){
        return true;
    }

    return false;
}

function getPostPics( $post)
{
    if( $post == NEGRU){
        $pics = "<img src='imagini/post.png' />";
    } else {
        $pics = '';
        for( $i = 8; $i >= 0; $i--){
            if( $post & (1 << $i)){
                $pics .= "<img src='imagini/post-$i.png' />";
                if( $i < 8){
                    break;
                }
            }
        }

        if( $post > PESTE && $post < CARNE){
            $pics .= "<img src='imagini/post-4.png' />";
        }
    }
    return $pics;
}

function getPostText( $post, $zi )
{
    global $ls;
    $text = false;
    if(( $post & CARNE) == CARNE){
        if( $zi["wday"] == 3 || $zi["wday"] == 5){
            $text = $ls->CARNE;
        }
	}
    elseif(( $post & LAPTE_OUA) == LAPTE_OUA) $text = $ls->LAPTE_OUA;
    elseif(( $post & PESTE) == PESTE) $text = $ls->PESTE;
    elseif(( $post & ULEI_VIN) == ULEI_VIN) $text = $ls->ULEI_VIN;
    elseif(( $post & VEGETARIAN) == VEGETARIAN) $text = $ls->VEGETARIAN;
    elseif(( $post & GRAU_MIERE) == GRAU_MIERE) $text = $ls->GRAU_MIERE;
    elseif(( $post & PAINE_APA) == PAINE_APA) $text = $ls->PAINE_APA;
    elseif(( $post & NEGRU) == NEGRU) $text = $ls->NEGRU;

    if(( $post & NUNTI) != NUNTI){
        if( $text){
            $text .= ". ";
        }
        $text .= $ls->nunti;
    }
    return $text;
}
?>